import { Loader, LoadingManager, RawShaderMaterial, ShaderMaterialParameters, Object3D } from 'three';
import { GLTFParser, GLTF } from 'three/examples/jsm/loaders/GLTFLoader';

declare class TiltShaderLoader extends Loader {
    constructor(manager: LoadingManager);
    load(brushName: string, onLoad: (response: RawShaderMaterial) => void, onProgress?: (event: ProgressEvent) => void, onError?: (event: ErrorEvent) => void): Promise<void>;
    parse(rawMaterial: RawShaderMaterial): RawShaderMaterial;
    lookupMaterial(nameOrGuid: string): ShaderMaterialParameters;
}

declare class GLTFGoogleTiltBrushMaterialExtension {
    constructor(parser: GLTFParser, brushPath: string);
    beforeRoot(GLTF: GLTF);
    afterRoot(GLTF: GLTF);
    replaceMaterial(mesh: Object3D, guid: string);
}

export { GLTFGoogleTiltBrushMaterialExtension, TiltShaderLoader };
